#include <stdio.h>
#include <string>
#include <vector>
#include <cstring>
#include <algorithm>
#include <math.h>
using namespace std;

#define PI 3.1415926535897932
#define Nul 0.000000001

struct point{
    double x, y;
    double ang;
};

const int MaxN = 305;
point t[MaxN];
int c[MaxN], d[MaxN], n;

double Angle(double x, double y){
    if (x == 0.0) return 90.0;
    if (x > 0.0) return atan(y/x) * 180.0 / PI;
    return 180.0 - atan(-y/x) * 180.0 / PI;
}

bool cmp(point a, point b){
    return a.ang < b.ang || ( fabs(a.ang - b.ang) < Nul && (a.y < b.y || (a.y == b.y && a.x < b.x )));
}

//a b 1
//c d 1
//e f 1

double VP(double a, double b, double c, double d, double e, double f){
    return a*d + b*e + c*f - d*e - a*f - b*c;
}

int BF(){
    int sol = 0;
    for (int i = 1; i <= n-2; i++)
        for (int j = i+1; j <= n-1; j++)
            for (int k = j+1; k <= n; k++) if (fabs(VP(t[ i ].x, t[ i ].y, t[ j ].x, t[ j ].y, t[ k ].x, t[ k ].y)) > Nul) {
                int x = 0;
                for (int l = 1; l <= n; l++) if (i != l && j != l && k != l){
                    double vp1, vp2, vp3, vp;
                    vp1 = fabs(VP(t[ i ].x, t[ i ].y, t[ j ].x, t[ j ].y, t[ l ].x, t[ l ].y));
                    vp2 = fabs(VP(t[ i ].x, t[ i ].y, t[ k ].x, t[ k ].y, t[ l ].x, t[ l ].y));
                    vp3 = fabs(VP(t[ k ].x, t[ k ].y, t[ j ].x, t[ j ].y, t[ l ].x, t[ l ].y));
                    vp  = fabs(VP(t[ i ].x, t[ i ].y, t[ j ].x, t[ j ].y, t[ k ].x, t[ k ].y));
                    if (fabs( vp - vp1 - vp2 - vp3 ) < Nul) x++;
                }

                if (sol < 3 + x) sol = 3 + x;
            }

    //printf("%d\n", sol);
    return sol;
}

int BF2(int cs, int bs){
    int sol = 0;
    for (int i = 1; i <= cs-2; i++)
        for (int j = i+1; j <= cs-1; j++)
            for (int k = 1; k <= n; k++) if (i != k && j != k)
            if (fabs(VP(t[ c[i] ].x, t[ c[i] ].y, t[ c[j] ].x, t[ c[j] ].y, t[ k ].x, t[ k ].y)) > Nul) {
                int x = 0;
                for (int l = 1; l <= bs; l++) if (k != l){
                    double vp1, vp2, vp3, vp;
                    vp1 = fabs(VP(t[ c[i] ].x, t[ c[i] ].y, t[ c[j] ].x, t[ c[j] ].y, t[ d[l] ].x, t[ d[l] ].y));
                    vp2 = fabs(VP(t[ c[i] ].x, t[ c[i] ].y, t[ k ].x, t[ k ].y, t[ d[l] ].x, t[ d[l] ].y));
                    vp3 = fabs(VP(t[ k ].x, t[ k ].y, t[ c[j] ].x, t[ c[j] ].y, t[ d[l] ].x, t[ d[l] ].y));
                    vp  = fabs(VP(t[ c[i] ].x, t[ c[i] ].y, t[ c[j] ].x, t[ c[j] ].y, t[ k ].x, t[ k ].y));
                    if (fabs( vp - vp1 - vp2 - vp3 ) < Nul) x++;
                }

                if (sol < 3 + x) sol = 3 + x;
            }

    //printf("%d\n", sol);
    return sol;
}

int main(){
    FILE *f = fopen("trougao.in", "r");
    FILE *g = fopen("trougao.out", "w");
    fscanf(f, "%d", &n);

    int z = 1;
    for (int i = 1; i <= n; i++){
        double x, y;
        fscanf(f, "%lf%lf", &x, &y);
        t[i].x = x; t[i].y = y;
        if (t[z].y > t[i].y || (t[z].y == t[i].y && t[z].x > t[i].x)) z = i;
    }

    if (n <= 100){
        int sol = BF();
        fprintf(g, "%d\n", sol);
        fclose(f); fclose(g);
        return 0;
    }

    point p = t[1]; t[1] = t[z]; t[z] = p;

    for (int i = 2; i <= n; i++) t[i].ang = Angle(t[i].x - t[1].x, t[i].y - t[1].y);

    //for (int i = 2; i <= n; i++) printf("%.6lf ", t[i].ang);
    sort(t+2, t+n+1, cmp);
    //for (int i = 1; i <= n; i++) printf("%.6lf %.6lf\n", t[i].x, t[i].y); printf("\n");

    //printf("%.6lf\n", VP(3, 1, 3, 2, 4, 4));

    c[1] = 1; c[2] = 2;
    int i = 3, cs = 2;
    while (i <= n){
        while ( VP( t[ c[cs-1] ].x, t[ c[cs-1] ].y, t[ c[cs] ].x, t[ c[cs] ].y, t[ i ].x, t[ i ].y) > -Nul && i <= n){
            cs++; c[cs] = i; i++;
        }
        //printf("cs = %d, i = %d\n", cs, i);

        if (i > n) break;
        cs++; c[cs] = i; i++;
        while ( VP( t[ c[cs-2] ].x, t[ c[cs-2] ].y, t[ c[cs-1] ].x, t[ c[cs-1] ].y, t[ c[cs] ].x, t[ c[cs] ].y) < -Nul ){
            c[cs-1] = c[cs]; cs--;
        }
    }

    //for (int i = 1; i <= cs; i++) printf("%d ", c[i]); printf("\n\n");
    bool mark[MaxN];
    for (int i = 1; i <= n; i++) mark[i] = false;

    for (int i = 1; i <= cs; i++) mark[ c[i] ] = true;

    int bs = 0;
    for (int i = 1; i <= n; i++)
        if (!mark[i]){
            bs++; d[bs] = i;
        }

    if (cs*cs*n*bs <= 100000000){
        int sol = BF2(cs, bs);
        fprintf(g, "%d\n", sol);
        fclose(f); fclose(g);
        return 0;
    }

    int sol = 0;
    for (int i = 1; i <= cs-2; i++)
        for (int j = i+1; j <= cs-1; j++)
            for (int k = j+1; k <= cs; k++) if (fabs(VP(t[ c[i] ].x, t[ c[i] ].y, t[ c[j] ].x, t[ c[j] ].y, t[ c[k] ].x, t[ c[k] ].y)) > Nul) {
                int x = 0;
                for (int l = 1; l <= bs; l++){
                    double vp1, vp2, vp3, vp;
                    vp1 = fabs(VP(t[ c[i] ].x, t[ c[i] ].y, t[ c[j] ].x, t[ c[j] ].y, t[ d[l] ].x, t[ d[l] ].y));
                    vp2 = fabs(VP(t[ c[i] ].x, t[ c[i] ].y, t[ c[k] ].x, t[ c[k] ].y, t[ d[l] ].x, t[ d[l] ].y));
                    vp3 = fabs(VP(t[ c[k] ].x, t[ c[k] ].y, t[ c[j] ].x, t[ c[j] ].y, t[ d[l] ].x, t[ d[l] ].y));
                    vp  = fabs(VP(t[ c[i] ].x, t[ c[i] ].y, t[ c[j] ].x, t[ c[j] ].y, t[ c[k] ].x, t[ c[k] ].y));
                    if (fabs( vp - vp1 - vp2 - vp3 ) < Nul) x++;
                }

                if (sol < 3 + x) sol = 3 + x;
            }

    fprintf(g, "%d\n", sol);
    fclose(f); fclose(g);
    return 0;
}
